#!/usr/bin/perl
$MaxLine=100;
$MaxComment=400;
$MaxName=20;
read(STDIN,$FormData,$ENV{'CONTENT_LENGTH'});
&WriteData;
&OutLocation($ENV{HTTP_REFERER});


###
sub WriteData{
	my($comment,$name,$time,@bbs);
	$comment=&ContentEncode(&GetValue($FormData,"COMMENT"));
	$name=&NameEncode(&GetValue($FormData,"NAME"));
	exit if(length($comment)>$MaxComment || length($name)>$MaxName);
	$time=&TimeEncode(time);
	open(FILE,"bbs.data");
	@bbs=<FILE>;
	close(FILE);
	unshift(@bbs,"$comment<>$name<>$time<>\n");
	while($#bbs>=$MaxLine){
		pop(@bbs);
	}
	open(FILE,"+>bbs.data");
	print FILE @bbs;
	close(FILE);
}
###
sub TimeEncode{
	my(@time);
	@time=localtime(shift);
	$time[4]++;
	$time[4]="0".$time[4] if(length($time[4])==1);
	$time[3]="0".$time[3] if(length($time[3])==1);
	$time[2]="0".$time[2] if(length($time[2])==1);
	$time[1]="0".$time[1] if(length($time[1])==1);
	return("$time[4]/$time[3] $time[2]:$time[1]");
}
###
sub NameEncode{
	my($str);
	$str=shift;
	$str=&UrlUnescape($str);
	$str=&MetaEscape($str);
	$str=~s/\r//g;
	$str=~s/\n//g;
	$str="No name" if(!$str);
	return($str);
}
###
sub ContentEncode{
	my($str);
	$str=shift;
	$str=&UrlUnescape($str);
	$str=&MetaEscape($str);
	$str=~s/(http:\/\/[\w\!\#\$\%\&\'\(\)\=\-\~\^\|\\\@\{\[\+\;\*\:\}\],\.\/\?\_]+)/&AutoLink($1)/eg;
	$str=~s/\r//g;
	$str=~s/\n/<br>/g;
	return($str);
}
###
sub AutoLink{
	my($href,$text);
	$href=shift;
	$text=$href;
	$href=~s/&amp;/&/g;
	return("<a href='$href' target='_blank'>$text<\/a>");
}
###
sub MetaEscape{
	my($str);
	$str=shift;
	$str=~s/&/&amp;/g;
	$str=~s/\"/&quot;/g;
	$str=~s/</&lt;/g;
	$str=~s/>/&gt;/g;
	return($str);
}
###
sub UrlUnescape{
	my($str);
	$str=$_[0];
	$str=~tr/+/ /;
	$str=~s/%([0-9A-Fa-f][0-9A-Fa-f])/pack("H2",$1)/eg;
	return($str);
}
###
sub GetValue{
	my(@objects);
	@objects=split(/[&]/,$_[0]);
	foreach(@objects){
		return($1) if(/^$_[1]=(.+)$/);
	}
	return;
}
###
sub OutLocation{
	print "Location:$_[0]\n\n";
	exit;
}
###

